# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PageEventContent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'details': 'str',
        'resource_name': 'str',
        'resource_type': 'str',
        'timestamp': 'datetime',
        'has_logs': 'bool',
        'user_event': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'details': 'details',
        'resource_name': 'resourceName',
        'resource_type': 'resourceType',
        'timestamp': 'timestamp',
        'has_logs': 'hasLogs',
        'user_event': 'userEvent'
    }

    def __init__(self, id=None, name=None, details=None, resource_name=None, resource_type=None, timestamp=None, has_logs=None, user_event=None):  # noqa: E501
        """PageEventContent - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._details = None
        self._resource_name = None
        self._resource_type = None
        self._timestamp = None
        self._has_logs = None
        self._user_event = None
        self.discriminator = None
        if id is not None:
            self.id = id
        self.name = name
        if details is not None:
            self.details = details
        if resource_name is not None:
            self.resource_name = resource_name
        if resource_type is not None:
            self.resource_type = resource_type
        self.timestamp = timestamp
        if has_logs is not None:
            self.has_logs = has_logs
        if user_event is not None:
            self.user_event = user_event

    @property
    def id(self):
        """Gets the id of this PageEventContent.  # noqa: E501

        Event identifier  # noqa: E501

        :return: The id of this PageEventContent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PageEventContent.

        Event identifier  # noqa: E501

        :param id: The id of this PageEventContent.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this PageEventContent.  # noqa: E501

        Short user-friendly label of the event (e.g. 'shutting down myVM')  # noqa: E501

        :return: The name of this PageEventContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PageEventContent.

        Short user-friendly label of the event (e.g. 'shutting down myVM')  # noqa: E501

        :param name: The name of this PageEventContent.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def details(self):
        """Gets the details of this PageEventContent.  # noqa: E501

        Longer user-friendly details of the event.  # noqa: E501

        :return: The details of this PageEventContent.  # noqa: E501
        :rtype: str
        """
        return self._details

    @details.setter
    def details(self, details):
        """Sets the details of this PageEventContent.

        Longer user-friendly details of the event.  # noqa: E501

        :param details: The details of this PageEventContent.  # noqa: E501
        :type: str
        """

        self._details = details

    @property
    def resource_name(self):
        """Gets the resource_name of this PageEventContent.  # noqa: E501

        Optional resource name to which the event applies to  # noqa: E501

        :return: The resource_name of this PageEventContent.  # noqa: E501
        :rtype: str
        """
        return self._resource_name

    @resource_name.setter
    def resource_name(self, resource_name):
        """Sets the resource_name of this PageEventContent.

        Optional resource name to which the event applies to  # noqa: E501

        :param resource_name: The resource_name of this PageEventContent.  # noqa: E501
        :type: str
        """

        self._resource_name = resource_name

    @property
    def resource_type(self):
        """Gets the resource_type of this PageEventContent.  # noqa: E501

        Optional resource type to which the event applies to  # noqa: E501

        :return: The resource_type of this PageEventContent.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this PageEventContent.

        Optional resource type to which the event applies to  # noqa: E501

        :param resource_type: The resource_type of this PageEventContent.  # noqa: E501
        :type: str
        """

        self._resource_type = resource_type

    @property
    def timestamp(self):
        """Gets the timestamp of this PageEventContent.  # noqa: E501

        Timestamp of the Event (e.g. date format '2019-07-13T23:16:49.310Z').  # noqa: E501

        :return: The timestamp of this PageEventContent.  # noqa: E501
        :rtype: datetime
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this PageEventContent.

        Timestamp of the Event (e.g. date format '2019-07-13T23:16:49.310Z').  # noqa: E501

        :param timestamp: The timestamp of this PageEventContent.  # noqa: E501
        :type: datetime
        """
        if timestamp is None:
            raise ValueError("Invalid value for `timestamp`, must not be `None`")  # noqa: E501

        self._timestamp = timestamp

    @property
    def has_logs(self):
        """Gets the has_logs of this PageEventContent.  # noqa: E501

        Indicates whether the event has logs or not.  # noqa: E501

        :return: The has_logs of this PageEventContent.  # noqa: E501
        :rtype: bool
        """
        return self._has_logs

    @has_logs.setter
    def has_logs(self, has_logs):
        """Sets the has_logs of this PageEventContent.

        Indicates whether the event has logs or not.  # noqa: E501

        :param has_logs: The has_logs of this PageEventContent.  # noqa: E501
        :type: bool
        """

        self._has_logs = has_logs

    @property
    def user_event(self):
        """Gets the user_event of this PageEventContent.  # noqa: E501

        Indicates if the event represents user input.  # noqa: E501

        :return: The user_event of this PageEventContent.  # noqa: E501
        :rtype: bool
        """
        return self._user_event

    @user_event.setter
    def user_event(self, user_event):
        """Sets the user_event of this PageEventContent.

        Indicates if the event represents user input.  # noqa: E501

        :param user_event: The user_event of this PageEventContent.  # noqa: E501
        :type: bool
        """

        self._user_event = user_event

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PageEventContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PageEventContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
